{system/conversion/conversion_progress.i}
/*------------------------------------------------------------------------
  File: aa/conversion/10.03/aa-1003-after-01-aa-edi-schedule-comm.p
  Doel: aa-edi-schedule-comm records updaten met "juiste" schedulerid_code en comm_schedulerid_code. Eventueel overgebleven records (die niet zijn verwidjerd door verkeerde delete trigger alsnog verwijderen
        
------------------------------------------------------------------------*/
DEF VAR cProgram                      AS CHAR NO-UNDO.
DEF VAR cAction                       AS CHAR NO-UNDO.
DEF VAR iDone                         AS INT  NO-UNDO.

ASSIGN cProgram =  "aa-1003-after-01-aa-edi-schedule-comm.p".

FORM "Program  :" AT 1 cProgram   NO-LABEL  FORMAT "x(50)"    AT 12  SKIP
     "Action   :" AT 1 cAction    NO-LABEL  FORMAT "x(50)"    AT 12  SKIP
     "Done     :" AT 1 iDone      NO-LABEL  FORMAT "9999999"  AT 12  SKIP   
     WITH FRAME a.



DO TRANSACTION:
  ASSIGN cAction  = "Converteren Scheduled tasks send-to records"
         iDone    = 0.
  RUN DisplayProgress (cProgram, cAction, ''    , 0     , iDone).
  
  /* 2010-05-26 JEE Vullen schedulerid_code in de aa-edi-schedule-comm records; NB ivm verkeerde trigger zijn er vaak ook "zwervende" schedule-comm records; die deleten we gelijk */
  /* 2010-05-27 JEE Er zijn soms ook records met niet (meer) bestaande schedulerIDs! */
  FOR EACH aa-edi-schedule-comm WHERE
    EXCLUSIVE-LOCK:

    FIND aa-edi-schedule WHERE
         aa-edi-schedule.schedule_code = aa-edi-schedule-comm.schedule_code
      NO-LOCK NO-ERROR.
    IF AVAILABLE aa-edi-schedule
    THEN DO:
      /* Is er al een scheduler id ingevuld? */
      IF aa-edi-schedule-comm.schedulerid_code <> ""
      THEN DO:
        FIND aa-edi-scheduler WHERE
             aa-edi-scheduler.schedulerid_code = aa-edi-schedule-comm.schedulerid_code
          NO-LOCK NO-ERROR.
        IF NOT AVAILABLE aa-edi-scheduler
        THEN ASSIGN aa-edi-schedule-comm.schedulerid_code = aa-edi-schedule.schedulerid_code.
      END.
      ELSE ASSIGN aa-edi-schedule-comm.schedulerid_code = aa-edi-schedule.schedulerid_code.

      /* Is er een goede comm scheduler id ingevuld? */
      IF aa-edi-schedule-comm.comm_schedulerid_code <> ""
      THEN DO:
        FIND aa-edi-scheduler WHERE
             aa-edi-scheduler.schedulerid_code = aa-edi-schedule-comm.comm_schedulerid_code
          NO-LOCK NO-ERROR.
        IF NOT AVAILABLE aa-edi-scheduler
        THEN ASSIGN aa-edi-schedule-comm.comm_schedulerid_code = aa-edi-schedule.schedulerid_code.
      END.
      ELSE ASSIGN aa-edi-schedule-comm.comm_schedulerid_code = aa-edi-schedule.schedulerid_code.

    END. /* IF AVAILABLE aa-edi-schedule */
    ELSE DELETE aa-edi-schedule-comm.

    iDone = iDone  + 1.
    RUN DisplayProgress (cProgram, cAction, ''    , 0     , iDone).

  END. /* FOR EACH aa-edi-schedule-comm */
END. /* TRANSACTION */


RUN DisplayProgress (cProgram, cAction, ''    , 0     , iDone).
