{System/conversion/conversion_progress.i}

DEF VAR cPathSeperator       AS CHAR INIT "~\" NO-UNDO.
DEF VAR cWinPathSeperator    AS CHAR INIT "~\" NO-UNDO.
DEF VAR cUnixPathSeperator   AS CHAR INIT "/" NO-UNDO.
DEF VAR cWorkingDirectory    AS CHAR   NO-UNDO.






/* 2017-08-07 JEE Deze conversie niet standaard draaien ivm lange tijd die deze conversie kan duren ! */
RETURN.

















FUNCTION UniPath RETURNS CHARACTER
  ( INPUT pcValue AS CHARACTER  ) :
/*------------------------------------------------------------------------------
  Purpose:  omzetten naar een universeel path  win32=\  unix=/
            je krijgt dus nu een pad of bestandnaam met altijd dezelfde sep.
    Notes:  rdb 14-3-2003
------------------------------------------------------------------------------*/
  DEF VAR cValue AS CHAR NO-UNDO.

  /*- vervang de pathseperators zodat het altijd werkt -*/
  cValue = REPLACE(pcValue, cWinPathSeperator, cPathSeperator).
  cValue = REPLACE(cValue, cUnixPathSeperator, cPathSeperator).

  RETURN cValue.   /* Function return value. */

END FUNCTION.



DEFINE VARIABLE cProgram AS CHARACTER NO-UNDO FORMAT "x(50)".
DEFINE VARIABLE cAction  AS CHARACTER NO-UNDO FORMAT "X(50)".
DEFINE VARIABLE cTable   AS CHARACTER NO-UNDO FORMAT "X(50)".
DEFINE VARIABLE iTotal   AS INTEGER   NO-UNDO.
DEFINE VARIABLE iDone    AS INTEGER   NO-UNDO.
DEFINE VARIABLE iLoop    AS INTEGER   NO-UNDO.
DEFINE VARIABLE lFound   AS LOGICAL   NO-UNDO.

DISABLE TRIGGERS FOR LOAD OF aa-attachment.

ASSIGN
  cProgram = THIS-PROCEDURE:FILE-NAME
  cAction  = "Counting filesize = 0"
  cTable   = "aa-attachment"
  iTotal   = 0
  iDone    = 0
  .


FUNCTION spAttachmentFilePath RETURNS CHARACTER
  (pcRecordType AS CHARACTER) :
  /* (pcRecordType AS CHARACTER) : */

/*------------------------------------------------------------------------------
  Purpose:
    Notes:
------------------------------------------------------------------------------*/
  DEF VAR cLocation                 AS CHARACTER NO-UNDO.
  DEF VAR iLoop                     AS INTEGER   NO-UNDO.
  DEF VAR cCompanyPath              AS CHARACTER NO-UNDO.

  FIND aa-attachment_setting WHERE
       aa-attachment_setting.recordtype  = pcRecordType
    NO-LOCK NO-ERROR.

  IF AVAILABLE aa-attachment_setting
  THEN cLocation = aa-attachment_setting.filepath.
  ELSE cLocation = "".

  RETURN cLocation.   /* Function return value. */

END FUNCTION.


DEF VAR lDelete         AS LOGICAL   NO-UNDO.
DEF VAR cType           AS CHARACTER NO-UNDO.
DEF VAR cFile           AS CHARACTER NO-UNDO.
DEF VAR cLocation       AS CHARACTER NO-UNDO.
DEF VAR lOk             AS LOGICAL   NO-UNDO.
DEF VAR iLocLoop        AS INTEGER   NO-UNDO.
DEF VAR cLocLoop        AS CHARACTER NO-UNDO.
DEF VAR cTestLoc        AS CHARACTER NO-UNDO.
DEF VAR iTel            AS INTEGER   NO-UNDO.

DEFINE TEMP-TABLE tt-attachment LIKE aa-attachment.

FOR EACH aa-attachment WHERE
         aa-attachment.filesize = 0
  NO-LOCK.
  CREATE tt-attachment.
  BUFFER-COPY aa-attachment TO tt-attachment.
  ASSIGN
    iTel   = iTel + 1
    iTotal = iTotal + 1
    .
  IF iTel = 100
  THEN DO:
    iTel = 0.
    RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
  END.

END.

ASSIGN
  cAction = "Checking filesize"
  iTel    = 0
  .

FOR EACH tt-attachment:

  ASSIGN
    lDelete             = FALSE
    FILE-INFO:FILENAME  = ""
    cLocation           = ""
    .

  IF tt-attachment.blobnr <> 0
  THEN DO:
    RUN aaBlobLoad(tt-attachment.blobnr, OUTPUT cType, OUTPUT cFile, OUTPUT lok).
    IF lOk
    THEN FILE-INFO:FILENAME = cFile NO-ERROR.
    ELSE lDelete = TRUE.
  END.
  ELSE DO:
    cLocation = spAttachmentFilePath(tt-attachment.recordtype).
    IF cLocation <> ""
    THEN DO:

      /* pad per companycode ? */
      /* 2017-08-07 JEE Wij gaan nu vanuit de attachment naar de file (ipv uit een dossier of wat dan ook) en weten dus ook niet in welke companycode dit zit. gewoon 1 voor 1 proberen en hopen dat we een bestand kunnen vinden */
      IF NUM-ENTRIES(cLocation) > 1
      THEN
      LocLoop:
      DO iLocLoop = 1 TO NUM-ENTRIES(cLocation):
        cLocLoop = ENTRY(iLocLoop, cLocation).

        IF NUM-ENTRIES(cLocLoop, "=") = 2
        THEN DO:
          cTestLoc = ENTRY(2, cLocLoop, "=").
          FILE-INFO:FILENAME = cTestLoc + "~\" + tt-attachment.target_filename NO-ERROR.
          IF SUBSTRING(FILE-INFO:FILE-TYPE, 1, 1) = "F"
          THEN DO:
            cLocation = cTestLoc.
            LEAVE LocLoop.
          END.
        END.
      END. /* LocLoop */

      IF cLocation <> ""
      THEN FILE-INFO:FILENAME = cLocation + "~\" + tt-attachment.target_filename NO-ERROR.
    END.
    ELSE lDelete = TRUE.
  END.

  IF lDelete = TRUE
  THEN DELETE tt-attachment.
  ELSE DO:
    IF SUBSTRING(FILE-INFO:FILE-TYPE, 1, 1) = "F"
    THEN tt-attachment.filesize = FILE-INFO:FILE-SIZE NO-ERROR.
    IF tt-attachment.filesize = 0 OR tt-attachment.filesize = ?
    THEN DELETE tt-attachment.
  END.

  ASSIGN
    iTel  = iTel + 1
    iDone = iDone + 1
    .

  IF iTel = 25
  THEN DO:
    iTel = 0.
    RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
  END.
END. /* FOR EACH tt-attachment  */

RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).

ASSIGN
  iDone   = 0
  iTotal  = 0
  cAction = "Counting filesize found"
  iTel    = 0
  .

RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).

FOR EACH tt-attachment:
  ASSIGN
    iTel   = iTel + 1
    iTotal = iTotal + 1
    .

  IF iTel = 100
  THEN DO:
    iTel = 0.
    RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
  END.
END.

ASSIGN
  cAction = "Writing filesize"
  iTel    = 0.

RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).

ttLoop:
REPEAT:

  RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).

  DO TRANSACTION:
    FOR EACH tt-attachment WHERE
             tt-attachment.filesize <> 0:

      FIND aa-attachment WHERE
           aa-attachment.attachmentnr = tt-attachment.attachmentnr
       AND aa-attachment.seqnr        = tt-attachment.seqnr
        EXCLUSIVE-LOCK.

      ASSIGN
        aa-attachment.filesize = tt-attachment.filesize
        iDone                  = iDone + 1
        iTel                   = iTel + 1
        .

      DELETE tt-attachment.

      IF iTel = 100
      THEN DO:
        iTel = 0.
        NEXT ttLoop.
      END.
    END.
  END.

  LEAVE ttLoop.
END.

RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).


PROCEDURE aaBlobLoad :
/*------------------------------------------------------------------------------
  Purpose:     ophalen van een bestand uit de aa-blob tabel
  Parameters:  <none>
  Notes:       rdb 31-10-2005
  m.i.v. release 7.3 nieuwe parameter pcObjectType
------------------------------------------------------------------------------*/
  DEFINE INPUT   PARAMETER piBlobnr     AS INTEGER    NO-UNDO.
  DEFINE OUTPUT  PARAMETER pcObjectType AS CHARACTER  NO-UNDO.
  DEFINE OUTPUT  PARAMETER pcFilename   AS CHARACTER  NO-UNDO.
  DEFINE OUTPUT  PARAMETER plok         AS LOGICAL.

  DEF VAR cSavedFile                  AS CHARACTER NO-UNDO.

  /*- eerst even blob opzoeken om de filenaam te bepalen -*/
  FIND FIRST aa-blob WHERE
             aa-blob.blobnr = piBlobnr
             NO-LOCK NO-ERROR.
  IF AVAILABLE aa-blob
  THEN DO:
    cSavedFile   = SESSION:TEMP-DIRECTORY + aa-blob.Filename.
    pcObjectType = aa-blob.objecttype_code.
    OUTPUT TO VALUE(cSavedFile) NO-MAP NO-CONVERT BINARY.

    FOR EACH aa-blob WHERE
             aa-blob.blobnr = piBlobnr
             NO-LOCK :
        PUT CONTROL aa-blob.data.
        plok = TRUE.
    END.
    OUTPUT CLOSE.

    /*- geef de naam van het lokaal opgeslagen bestand terug -*/
    pcFileName = cSavedFile.
  END.
END PROCEDURE.

