{system/conversion/conversion_progress.i}
/*------------------------------------------------------------------------
  File: aa/conversion/11.02/aa-1102-after-01-exact.p
  Doel: 
------------------------------------------------------------------------*/
DEF VAR cProgram                      AS CHAR NO-UNDO.
DEF VAR cAction                       AS CHAR NO-UNDO.
DEF VAR iDone                         AS INT  NO-UNDO.

ASSIGN cProgram =  "aa-1103-after-02-fin-report.p".

FORM "Program  :" AT 1 cProgram   NO-LABEL  FORMAT "x(50)"    AT 12  SKIP
     "Action   :" AT 1 cAction    NO-LABEL  FORMAT "x(50)"    AT 12  SKIP
     "Done     :" AT 1 iDone      NO-LABEL  FORMAT "9999999"  AT 12  SKIP   
     WITH FRAME a.



  ASSIGN cAction  = "Sync fin reports."
         iDone    = 0.
  RUN DisplayProgress (cProgram, cAction, ''    , 0     , iDone).
  
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

  DEFINE BUFFER b-aa-fin_report FOR aa-fin_report.
  
  DO TRANSACTION:

    FOR EACH sp-company NO-LOCK :

      FIND b-aa-fin_report WHERE TRUE 
       AND b-aa-fin_report.companycode = sp-company.companycode
       AND b-aa-fin_report.applicatiekode = 'AA'
       AND b-aa-fin_report.modelkode = 'XFIN_PAYMENT_AUTO_2'
       AND b-aa-fin_report.filename = 'AA\report\aa-fin_payment_cr-bulk-check-list.rpt'
       AND b-aa-fin_report.report_seqnr = 1
       EXCLUSIVE-LOCK NO-ERROR.
       IF NOT AVAILABLE b-aa-fin_report
       THEN CREATE b-aa-fin_report.
       ASSIGN 
       b-aa-fin_report.companycode = sp-company.companycode
       b-aa-fin_report.applicatiekode = 'AA'
       b-aa-fin_report.modelkode = 'XFIN_PAYMENT_AUTO_2'
       b-aa-fin_report.filename = 'AA\report\aa-fin_payment_cr-bulk-check-list.rpt'
       b-aa-fin_report.des = 'Payments Check List'
       b-aa-fin_report.text_objectnr = 0
       b-aa-fin_report.ind_inactive = no
       b-aa-fin_report.report_seqnr = 1
       .

      iDone = iDone  + 1.
      RUN DisplayProgress (cProgram, cAction, ''    , 0     , iDone).

    END.
    

  
  END.
  


RUN DisplayProgress (cProgram, cAction, ''    , 0     , iDone).
