{system/conversion/conversion_progress.i}
/*------------------------------------------------------------------------
  File: aa/conversion/11.03/aa-1103-after-03-aa-deposit-booked.p
  Doel: 
------------------------------------------------------------------------*/
DEF VAR cProgram                      AS CHAR NO-UNDO.
DEF VAR cAction                       AS CHAR NO-UNDO.
DEF VAR iDone                         AS INT  NO-UNDO.

ASSIGN cProgram =  "aa-1103-after-03-aa-deposit-booked.p".

FORM "Program  :" AT 1 cProgram   NO-LABEL  FORMAT "x(50)"    AT 12  SKIP
     "Action   :" AT 1 cAction    NO-LABEL  FORMAT "x(50)"    AT 12  SKIP
     "Done     :" AT 1 iDone      NO-LABEL  FORMAT "9999999"  AT 12  SKIP   
     WITH FRAME a.



  ASSIGN cAction  = "Set Booked status of deposit."
         iDone    = 0.
  RUN DisplayProgress (cProgram, cAction, ''    , 0     , iDone).
  
/*------------------------------------------------------------------------------
  Purpose:     Vul de nieuwe boeking-status veldjes in de deposits.
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

  DEFINE BUFFER b-aa-deposit_transaction FOR aa-deposit_transaction .
  DEFINE BUFFER b-aa-fin_receivable      FOR aa-fin_receivable.
  DEFINE BUFFER b-aa-fin_payment_cr      FOR aa-fin_payment_cr .
  
  DO TRANSACTION:

    FOR EACH b-aa-deposit_transaction EXCLUSIVE-LOCK
      WHERE b-aa-deposit_transaction.ind_invoiced EQ YES
        AND b-aa-deposit_transaction.ind_booked   EQ NO ,
      FIRST b-aa-fin_receivable NO-LOCK
      WHERE b-aa-fin_receivable.companycode     EQ b-aa-deposit_transaction.companycode
        AND b-aa-fin_receivable.invoice_keynr   EQ b-aa-deposit_transaction.invoicenr
        AND b-aa-fin_receivable.dt_paid         NE ?   /* d.w.z. totaal betaald! */ ,
      FIRST b-aa-fin_payment_cr
      WHERE b-aa-fin_payment_cr.companycode     EQ b-aa-deposit_transaction.companycode
        AND b-aa-fin_payment_cr.receivablenr    EQ b-aa-fin_receivable.receivablenr
        AND b-aa-fin_payment_cr.ind_paid        EQ TRUE
        AND b-aa-fin_payment_cr.ind_processed   EQ TRUE :
      
      ASSIGN
        b-aa-deposit_transaction.ind_booked             = TRUE
        b-aa-deposit_transaction.booked_sourcenr        = b-aa-fin_payment_cr.sourcenr
        b-aa-deposit_transaction.booked_transactioncode = b-aa-fin_payment_cr.transactioncode
        .
      
      iDone = iDone  + 1.
      RUN DisplayProgress (cProgram, cAction, ''    , 0     , iDone).

    END.  /* FOR EACH */
    
  END.
  


RUN DisplayProgress (cProgram, cAction, ''    , 0     , iDone).
