{System/conversion/conversion_progress.i}

/* ********************  Preprocessor Definitions  ******************** */

/* 2015-10-08 JEE Delete empty user */

/* ***************************  Main Block  *************************** */
DEF VAR cProgram                      AS CHARACTER NO-UNDO.
DEF VAR cAction                       AS CHARACTER NO-UNDO.
DEF VAR cTable                        AS CHARACTER NO-UNDO.
DEF VAR iTotal                        AS INTEGER   NO-UNDO.
DEF VAR iDone                         AS INTEGER   NO-UNDO.

/* --------------------------------------------------------------
  Disable triggers op de tabel indien dit mogelijk of
  onderzoek de effecten als de triggers aan moeten
  blijven staan
   -------------------------------------------------------------- */

DISABLE TRIGGERS FOR LOAD OF sp-user.

DEF BUFFER b-sp-user          FOR sp-user.
DEF BUFFER b-sp-user_password FOR sp-user_password.

ASSIGN
  cProgram  = THIS-PROCEDURE:FILE-NAME
  cTable    = "?"
  cAction   = "Update transaction nr "
  iTotal    = 123456
  .
iDone = 0.

RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).

  DEFINE BUFFER b-aa-fin_parameter       FOR aa-fin_parameter.
  DEFINE BUFFER b-aa-fin_payable_dossier FOR aa-fin_payable_dossier .
  DEFINE BUFFER b-aa-fin_payment_cr      FOR aa-fin_payment_cr .
  DEFINE BUFFER b-aa-fin_payment_db      FOR aa-fin_payment_db .

  DISABLE TRIGGERS FOR LOAD OF b-aa-fin_payable_dossier .
  DISABLE TRIGGERS FOR LOAD OF b-aa-fin_payment_cr .
  DISABLE TRIGGERS FOR LOAD OF b-aa-fin_payment_db .

  FOR EACH b-aa-fin_parameter
    NO-LOCK:

    FOR EACH aa-fin_payable_dossier
       WHERE aa-fin_payable_dossier.companycode   EQ b-aa-fin_parameter.companycode
         AND aa-fin_payable_dossier.transactionnr EQ 0 NO-LOCK:

      FIND FIRST aa-fin_transaction
           WHERE aa-fin_transaction.companycode     = b-aa-fin_parameter.companycode
             AND aa-fin_transaction.transactioncode = aa-fin_payable_dossier.transactioncode
             AND aa-fin_transaction.sourcenr        = aa-fin_payable_dossier.sourcenr
        NO-LOCK NO-ERROR.

      IF AVAILABLE aa-fin_transaction
      THEN DO TRANSACTION:
        FIND FIRST b-aa-fin_payable_dossier WHERE ROWID(b-aa-fin_payable_dossier) = ROWID(aa-fin_payable_dossier)
              EXCLUSIVE-LOCK NO-WAIT NO-ERROR.
        IF AVAILABLE b-aa-fin_payable_dossier
        THEN b-aa-fin_payable_dossier.transactionnr = aa-fin_transaction.transactionnr.

        iDone = iDone + 1.
        IF iDone MOD 100 = 0
        THEN RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).

      END.
    END.

    FOR EACH aa-fin_payment_cr
       WHERE aa-fin_payment_cr.companycode   EQ b-aa-fin_parameter.companycode
         AND aa-fin_payment_cr.transactionnr EQ 0 NO-LOCK:

      FIND FIRST aa-fin_transaction
           WHERE aa-fin_transaction.companycode     = b-aa-fin_parameter.companycode
             AND aa-fin_transaction.transactioncode = aa-fin_payment_cr.transactioncode
             AND aa-fin_transaction.sourcenr        = aa-fin_payment_cr.sourcenr
      NO-LOCK NO-ERROR.

      IF AVAILABLE aa-fin_transaction
      THEN DO TRANSACTION:
        FIND FIRST b-aa-fin_payment_cr WHERE ROWID(b-aa-fin_payment_cr) = ROWID(aa-fin_payment_cr)
               EXCLUSIVE-LOCK NO-WAIT NO-ERROR.
        IF AVAIL b-aa-fin_payment_cr
        THEN b-aa-fin_payment_cr.transactionnr = aa-fin_transaction.transactionnr.

        iDone = iDone + 1.
        IF iDone MOD 100 = 0
        THEN RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).

      END.
    END.

    FOR EACH aa-fin_payment_db
       WHERE aa-fin_payment_db.companycode   EQ b-aa-fin_parameter.companycode
         AND aa-fin_payment_db.transactionnr EQ 0 NO-LOCK:

      FIND FIRST aa-fin_transaction
           WHERE aa-fin_transaction.companycode     = b-aa-fin_parameter.companycode
             AND aa-fin_transaction.transactioncode = aa-fin_payment_db.transactioncode
             AND aa-fin_transaction.sourcenr        = aa-fin_payment_db.sourcenr NO-LOCK NO-ERROR.
      IF AVAILABLE aa-fin_transaction
      THEN DO TRANSACTION:
        FIND FIRST b-aa-fin_payment_db WHERE ROWID(b-aa-fin_payment_db) = ROWID(aa-fin_payment_db)
               EXCLUSIVE-LOCK NO-WAIT NO-ERROR.
        IF AVAIL b-aa-fin_payment_db
        THEN
          b-aa-fin_payment_db.transactionnr = aa-fin_transaction.transactionnr .

        iDone = iDone + 1.
        IF iDone MOD 100 = 0
        THEN RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).

      END.
    END.
  END.











